<?php
	global $guildmates,$guildmains,$AOC;

	/*Load guildmates if not set*/
	if (!$guildmates[0]) {
		say("Loading guildmates",1);
		$guildmates[0]=time();
		$historydir=@opendir($currentplugin."/history");	
		while (false !== ($history = readdir($historydir))) {
			if ($history!="."&&$history!="..") {
				if (!$guildmates[$history]) {
					$f1=fopen($currentplugin."/history/".$history,"r");
					if ($f1) {
						$b=fread($f1,64);
						fclose($f1);
						say ("Guildmate-Read :: $history talked on ".date("d.m.Y h:m:i",$b),1);
						$guildmates[$history]=$b;
					} else {
						unlink($currentplugin."/history/".$history);
						Say ("Guildmate-Read :: deleted corrupted file ".$currentplugin."/history/".$history."!",1);
					}
				} else {
					say ("Guildmate-Read :: $history ALREADY talked on ".date("d.m.Y h:m:i",$guildmates[$history]),1);
				}
			} 
		}
		@closedir($historydir);
	}

	/*Load main characters if not set*/
	if (!$guildmains[0]) {
		say("Loading main characters",1);
		$guildmains[0]=time();
		$mainchardir=@opendir($currentplugin."/mainchars");	
		while (false !== ($alt = readdir($mainchardir))) {
			if ($alt!="."&&$alt!="..") {
				if (!$guildmains[$alt]) {
					$f1=fopen($currentplugin."/mainchars/".$alt,"r");
					if ($f1) {
						$b=fread($f1,128);
						fclose($f1);
						say ("Maincharacter-Read :: Main of $alt is $b",1);
						$guildmains[$alt]=$b;
					} else {
						unlink($currentplugin."/mainchars/".$alt);
						Say ("Maincharacter-Read :: deleted corrupted file ".$currentplugin."/mainchars/".$alt."!",1);
					}
				} else {
					say ("Maincharacter-Read :: $alt ALREADY known as ".$guildmains[$alt],1);
				}
			} 
		}
		if ($mainchardir) @closedir($mainchardir);
	}


	/*Save timestamps & delete old buddies every 5 minutes*/
	if (time()-$guildmates[0]>300) {
		/* Save timestamps */
		say("Saving guildmates",1);
		$guildmates[0]=time();
		foreach ($guildmates as $name=>$time) {
			if ($name&&$time) {
				$f1=fopen($currentplugin."/history/".$name,"w+");
				if ($f1) fwrite($f1,($time+0));
				if ($f1) fclose($f1);
				#say ("Guildmate-Write :: $name talked on ".date("d.m.Y h:m:i",$time),1);
			} elseif (!$time) {
				say ("Guildmate-Write :: $name never talked Oo");
			}
			if ($name&&time()-$time>90*24*60*60) {
				unset($guildmates[$name]);
				say ("Guildmate-Delete:: $name didn't talk for 90 Days => deleted!",1);
				$AOC->buddy_remove($name);
				Say ("Guildmate-Delete:: deleted obsolete file ".$currentplugin."/history/".$name."!",1);
				unlink($currentplugin."/history/".$name);
			}
		}
	}

	/*Save main characters every 5 minutes*/
	if (time()-$guildmains[0]>300) {
		say("Saving main characters",1);
		$guildmains[0]=time();
		foreach ($guildmains as $alt=>$main) {
			if ($alt&&$main) {
				$f1=fopen($currentplugin."/mainchars/".$alt,"w+");
				if ($f1) fwrite($f1,($main));
				if ($f1) fclose($f1);
				#say ("Maincharacter-Write :: main character of $alt is $main",1);
			} elseif (!$main) {
				say ("Maincharacter-Write :: file invalid for alt $alt ($main)");
				Say ("Maincharacter-Delete:: deleted obsolete file ".$currentplugin."/mainchars/".$alt."!",1);
				unlink($currentplugin."/mainchars/".$alt);
				unset($guildmains[$alt]);
			}
		}
	}
	

?>